<script setup>
    const props = defineProps({
        day: {
            type: String,
            required: true
        },
        checkData : {
            type : Boolean,
            required: false,
            default: false
        }
    });
    const emit = defineEmits(["hours"]);
    const entries_list = ref([]);
    const is_active = computed(() => {
        return (entries_list.value.length > 0);
    });

    const checkDataWatcher=computed (()=>{
        return props.checkData;
    });

    watch (checkDataWatcher, () =>{
        checkReceptionHours ();
    });
  
    const warningClass= ref("");

    function emitHours() {
        emit("hours", entries_list.value);
    }
    function addEntry() { 
        entries_list.value.push([])

        emitHours();
    }
    function removeEntry() {
        entries_list.value.splice(-1, 1);
        checkReceptionHours ();

        emitHours();
    }
    function updateEntry(index, value) {
        entries_list.value[index] = value;
        checkReceptionHours ();

        emitHours();
    }

    function checkReceptionHours () {
        if (props.checkData){
            var datesValide=isReceptionScheduleDayValide (entries_list.value);

            if (datesValide){
                warningClass.value="";
            }else{
                warningClass.value=getClassWarning ();
            }
        }
    }
</script>

<template>
    <div :class="'w-[102px] flex flex-col items-center space-y-4'+warningClass">
        <FormReceptionTitle :day="day" :is_active="is_active" />
        <FormReceptionHours v-for="(entry, index) in entries_list" @update="(value) => updateEntry(index, value)" />
        <ButtonAdd @click="addEntry()"/>
        <ButtonRemove v-if="is_active" @click="removeEntry()" />
    </div>
</template>